# EngiBank WS

Webservice untuk Bank Engi

Service ini dideploy pada url berikut [http://engima.randiny.id:8080/WS-Bank/](http://engima.randiny.id:8080/WS-Bank/)

## Menjalankan

1. Buat war dengan menjalankan perintah 

```
mvn package
```

Atau unduh war terbaru dari [Gitlab](https://gitlab.informatika.org/if3110-2019-02-k03-12/ws-bank/-/jobs/artifacts/master/download?job=package)

2. Deploy .war ke server

## Dokumentasi

WS-Bank adalah sebuah webservice yang berhubungan dengan sebuah bank fiktif.
WS-Bank akan digunakan oleh aplikasi Engima dan Bank Pro.
Bank Pro menjadi user client general untuk WS-Bank sedangkan Engima akan menggunakan WS-Bank untuk sistem pemnbayarannya.

### Service

WS-Bank menawarkan beberapa service sebagai berikut

| Nama     | Deskripsi                                         |
| -------- | ------------------------------------------------- |
| Auth     | Autentikasi untuk login                           |
| User     | Melihat profil                                    |
| Account  | Membuat VA dan cek akun tujuan untuk pembayaran   |
| Transfer | Transfer dana, sejarah transfer, dan cek transfer |

### Format

Format interaksi dengan WS-Bank menggunakan sistem SOAP
Untuk beberapa service yang butuh autentikasi, key(yang didapat setelah login) harus diberikan di header

```xml
<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ser="http://service.engibank.com/">
   <soapenv:Header>
	<ser:authKey>
		<key>  {KEY HERE}  </key>
	</ser:authKey>
   </soapenv:Header>
   <soapenv:Body>
        ...
   </soapenv:Body>
</soapenv:Envelope>
```

### Basis data

Basis data yang digunakan mengikuti skema berikut

![schema](schema.png)

## Pembagian Tugas

1. CI/CD: 13517063
2. Eksplorasi: 13517063
3. Autentikasi: 13517063
4. Service
   1. Transfer: 13517060, 13517054
   2. Akun: 13517063, 13517060, 13517054


## URL Deployment

1. Akun: http://engima.randiny.id:8080/WS-Bank/services/account?wsdl
2. Transfer: http://engima.randiny.id:8080/WS-Bank/services/transfer?wsdl
3. Autentikasi: http://engima.randiny.id:8080/WS-Bank/services/auth?wsdl
4. Profile/user: http://engima.randiny.id:8080/WS-Bank/services/user?wsdl
