package com.engibank.model;

import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;


@Entity()
public class Transaction {

  @Id()
  @Column(nullable = false)
  @GeneratedValue(strategy = GenerationType.AUTO)
  private int id;

  @Column(nullable = false)
  private Date timestamp;

  @JoinColumn(nullable = false)
  @ManyToOne(optional = false)
  private Account from;

  @JoinColumn(nullable = false)
  @ManyToOne(optional = false)
  private Account to;

  @Column(nullable = false)
  private int amount;

  public Transaction() {
  }

  /**
   * Create new transaction.
   *
   * @param from   Source User
   * @param to     Destination User
   * @param amount Transfer amoun
   */
  public Transaction(Account from, Account to, int amount) {
    this.from = from;
    this.to = to;
    this.amount = amount;
    this.timestamp = new Date();
  }

  public int getAmount() {
    return amount;
  }

  public void setAmount(int amount) {
    this.amount = amount;
  }

  public Date getTimestamp() {
    return timestamp;
  }

  public void setTimestamp(Date timestamp) {
    this.timestamp = timestamp;
  }

  public Account getFrom() {
    return from;
  }

  public void setFrom(Account from) {
    this.from = from;
  }

  public Account getTo() { 
    return to; 
  }

  public void setTo(Account to) {
    this.to = to;
  }
}
