package com.engibank.service;

import com.engibank.model.User;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.jws.HandlerChain;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;

@HandlerChain(file = "../authKey.xml")
@WebService()
public class UserService {
  private static final Logger LOGGER = Logger.getLogger(UserService.class.getName());

  @Resource
  WebServiceContext context;

  /**
   * Get current user data.
   *
   * @return data of loggedin user
   */
  @WebMethod
  public User getMyProfile() {
    LOGGER.log(Level.FINE, "Profile request");

    MessageContext ctx = context.getMessageContext();
    User loggedinUser = (User) ctx.get("user");

    loggedinUser.setSecret(null);

    return loggedinUser;
  }
}
